{-# OPTIONS -fglasgow-exts #-}

{-| This is a very silly module. Maybe it should go away?
-}

module Syntax.Name where

import Data.Generics (Typeable, Data)
import Data.Char ( isAlpha )

import Syntax.Position

import Utils.Unicode

-- Names ------------------------------------------------------------------

--type Name = String
data Name = Name { nameRange   :: Range
		 , nameString' :: String
		 , nameId      :: Int
		 }
	  | DontCare
    deriving (Typeable, Data)

nameString DontCare = "_"
nameString x	    = nameString' x

instance Eq Name where
    DontCare == _	 = False
    _	     == DontCare = False
    x	     == y	 = nameId x == nameId y

instance Ord Name where
    compare DontCare _	= LT
    compare _ DontCare	= GT
    compare x y		= compare (nameId x) (nameId y)

instance HasRange Name where
    getRange DontCare	= noRange
    getRange x		= nameRange x

-- | Used for wild cards in patterns.
dontCare :: Name
dontCare = DontCare

isDontCare :: Name -> Bool
isDontCare DontCare = True
isDontCare _	    = False

dummyName :: String -> Name
dummyName s = Name noRange s 0

-- | Check if a name is an infix operator, i.e. if it starts with something
--   that isn'tAlpha. Something that starts with \'(\' is not an operator
--   either. This is a hack, to make some other hacks look good.
isOperator :: Name -> Bool
isOperator DontCare = False
isOperator (Name _ (c:s) _) =
    not $ or [ isAlpha c
	     , isUnicodeId c
	     , c == '_'
	     , c == '('
	     , c == '"'
	     ]
isOperator x	= error $ "impossible: isOperator " ++ show (nameString x)

